
#include "headio.h"
#include "Headped.H"

void infect(struct mar *m)
/*
   A recursive infection routine which flags up all marriages connected to
   marriage m.
   Used in finding the number of components in the pedigree.
*/

{
if (m->info.flag == DOWN)
  {
  struct marlist *ml;
  struct indlist *il;
  m->info.flag = UP;
  if (m->pa->par != nomar && m->pa->par->info.flag == DOWN) infect(m->pa->par);
  for (ml = m->pa->own; ml != nomarlist; ml = ml->next)
    if (ml->cur->info.flag == DOWN) infect(ml->cur);
  if (m->ma->par != nomar && m->ma->par->info.flag == DOWN) infect(m->ma->par);
  for (ml = m->ma->own; ml != nomarlist; ml = ml->next)
    if (ml->cur->info.flag == DOWN) infect(ml->cur); 
  for (il = m->kids ; il != noindlist ; il = il->next)
    for (ml = il->cur->own; ml != nomarlist; ml = ml->next)
      if (ml->cur->info.flag == DOWN) infect(ml->cur);
  }
}
