#include "headio.h"
#include "Headped.H"
#include "headrandom.h"
extern int someown(struct ind *);

void setindcoords(struct ind *x,float yunit)

/*
   Sets the x coordinate of individual x to be the average of the x coordinate
   of its parents' marriage and the average of the x coordinates of its own. 
   Sets the y coordinate of individual x to be one yunit larger that the largest
   of the y coordinates of its own marriages.
*/

{

if (someown(x))
  {
  float tot = 0.0, big = 0.0;
  int num = 0;
  struct marlist *ml;
  for (ml = x->own; ml != nomarlist; ml = ml->next)
    {
    if (ml->cur->info.flag != DOWN)
      {
      if (big < ml->cur->info.ycoord) big = ml->cur->info.ycoord;
      tot += ml->cur->info.xcoord;
      num ++;
      }
    }
  x->info.xcoord = tot/num;
  x->info.ycoord = big + yunit;
  if (x->par != nomar && x->par->info.flag != DOWN)
    {
    x->info.ycoord = (big + x->par->info.ycoord) /2.0 ;
    x->info.xcoord = (x->info.xcoord + x->par->info.xcoord) / 2.0 ;
    }
  }
else if (x->par != nomar && x->par->info.flag != DOWN)
  {
  x->info.xcoord = x->par->info.xcoord;
  x->info.ycoord = x->par->info.ycoord - yunit*.6;
  }
else 
  {
  x->info.xcoord = randu01();
  x->info.ycoord = randu01();
  }
}
