#include "headio.h"
#include "Headped.H"

extern void initmardat(struct mardat *);

struct mar *nextmar (void)

/*
   Returns the address of the next available storage space on the stack
   of marriages after initialising it.
*/

{
if (marpt >= maxmar)
  {
  fprintf(stderr,"\nERROR: no mar stack left\n" );
  fflush(stderr);
  return(nomar);
  }
else
  {
  marpt++;
  marstack[marpt].pa = noind;
  marstack[marpt].ma = noind;
  marstack[marpt].kids = noindlist;
  initmardat(&(marstack[marpt].info));
  return(&marstack[marpt]);
  }
}

