#include <string>
#include <fstream>
#include <iostream>

using namespace std;

int maxrowsize(const char *filename) {
  char c;
  ifstream is;
  is.open (filename);        // open file
  int m,j;
  m=j=0;
  while (is.good())     // loop while extraction from file is possible
  {
    c = is.get();       // get character from file
    j++;
    if(c == '\n'){ 
      if(j > m) m=j;
      j = 0;
    }
  }
  is.close();           // close file
  return m;
}

// counts lines and columns in 1st line of file `name'
int numlines(const char *filename, int &col){
  ifstream fp;
  int buff_size=maxrowsize(filename)+2;
  char *buff = new char[buff_size+1];
  
  fp.open(filename);
  fp.getline(buff,buff_size);
  col = 0;
  int n= 0;
  if(buff[0] != 0){
      col = 1;
      for(char *c=buff; *c != 0; c++)
	if(*c == ' ' || *c == '\t'){
	  col += 1;
	  c++;
	  while(*c == ' ' || *c == '\t') c++;
	  c--;
	}
  }
  while(!fp.eof()){
    fp.getline(buff,buff_size);
    n++;
  }
  fp.close();
  delete [] buff;
  return n;
}

// counts lines and columns in 1st line of `cin' and stores data in `outfile'
int numlines(int &col, const char *outfile){
  char buff[1025];
  int n=1;
  ofstream fp;
  fp.open(outfile);
  col = 0;
  cin.getline(buff,1024);
  fp << buff << endl;
  if(buff[0] != 0){
    col += 1;
    for(char *c=buff; *c != 0; c++)
      if(*c == ' ' || *c == '\t'){
	col += 1;
	c++;
	while(*c == ' ' || *c == '\t') c++;
	c--;
      }
  }
  while(cin.peek() != -1) {
    cin.getline(buff,1024);
    fp << buff << endl;
    n++;
  }
  fp.close();
  return n;
}


int numlines(const char *outfile){
  char buff[1025];
  int n=0;
  ofstream fp;
  char *c;
  int col;

  fp.open(outfile);
  while(cin.peek() != -1) {
    col =0;
    cin.getline(buff,1024);
    if(buff[0] != 0){
      col += 1;
      for(c=buff; *c != 0; c++)
	if(*c == ' ' || *c == '\t'){
	  col += 1;
	  c++;
	  while(*c == ' ' || *c == '\t') c++;
	  c--;
	}
    }
    fp << col << ' ' << buff << endl;
    n++;
  }
  fp.close();
  return n;
}


int numlines(const char *infile, const char *outfile){
  char buff[1025];
  int n=0;
  ofstream fp;
  char *c;
  int col;
  ifstream in;
  in.open(infile);
  fp.open(outfile);
  while(1) {
    col =0;
    in.getline(buff,1024);
    if(in.eof()) break;
    if(buff[0] != 0){
      col += 1;
      for(c=buff; *c != 0; c++)
	if(*c == ' ' || *c == '\t'){
	  col += 1;
	  c++;
	  while(*c == ' ' || *c == '\t') c++;
	  c--;
	}
    }
    fp << col << ' ' << buff << endl;
    n++;
  }
  fp.close();
  in.close();
  return n;
}
