// -*- C++ -*-
#ifndef __FL_PFIDDLER__
#define __FL_PFIDDLER__

#include <FL/Fl.H>
#include <FL/Fl_Widget.H>
#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>
#include <FL/fl_ask.H>
#include <FL/fl_file_chooser.H>
#include <FL/Fl_Color_Chooser.H>

class Drawing: public Fl_Widget{
  void draw();
 public:
  int handle(int);
  Drawing(int X, int Y, int W, int H, const char *label = 0) : 
    Fl_Widget(X,Y,W,H,label){};
};

int changemode(float, float, int *);
struct ind *closestind(float,float);
struct mar *closestmar(float,float);
void drawind(struct ind *, Fl_Color line = FL_BLACK);
void drawmar(struct mar *, Fl_Color line = FL_BLACK);
void do_icon(struct ind *, Fl_Color line = FL_BLACK);
void pink_it(struct ind *);

void drawped(Fl_Color line = FL_BLACK);

void move(struct ind *,float, float, Fl_Color line = FL_BLACK);
void move(struct mar *,float, float, Fl_Color line = FL_BLACK);
void moveprole(struct ind *,float, float, Fl_Color line = FL_BLACK);
void moveprole(struct mar *,float, float, Fl_Color line = FL_BLACK);

void zapind(struct ind *);
void zapfam(struct mar *);
void remove(struct ind *);
void dropdowncolor(struct ind *);
void dropupcolor(struct ind *);
void ordowncolor(struct ind *);
void orupcolor(struct ind *);
void anddowncolor(struct ind *);
void andupcolor(struct ind *);
void hidecolor(struct ind *);

float roundind(float y);
float roundmar(float y);
void align();
#endif



